# ![HAProxy](assets/images/haproxy-weblogo-210x49.png "HAProxy")

## Contributing guide

This document is a short guide for contributing to this project.

## API Specification - Development guide

Data Plane API is generated using [go-swagger](https://github.com/go-swagger/go-swagger) from the swagger spec found [here](https://github.com/haproxytech/dataplaneapi-specification/blob/master/build/haproxy_spec.yaml) using the following command.

```
./swagger generate server -f haproxy_spec.yaml \
    -A "Data Plane" \
    -t $GOPATH/src/github.com/haproxytech/ \
    --existing-models github.com/haproxytech/models/v2 \
    --exclude-main \
    --skip-models \
    -s dataplaneapi \
    --tags=Discovery \
    --tags=Information \
    --tags=Specification \
    --tags=SpecificationOpenapiv3 \
    --tags=Transactions \
    --tags=Sites \
    --tags=Stats \
    --tags=Global \
    --tags=Frontend \
    --tags=Backend \
    --tags=Bind \
    --tags=Server \
    --tags=Configuration \
    --tags=HTTPRequestRule \
    --tags=HTTPResponseRule \
    --tags=BackendSwitchingRule \
    --tags=ServerSwitchingRule \
    --tags=TCPResponseRule \
    --tags=TCPRequestRule \
    --tags=Filter \
    --tags=StickRule \
    --tags=LogTarget \
    --tags=Reloads \
    --tags=ACL \
    --tags=Defaults \
    --tags=StickTable \
    --tags=Maps \
    --tags=Nameserver \
    --tags=Cluster \
    --tags=Peer \
    --tags=PeerEntry \
    --tags=Resolver \
    -r ~/dataplaneapi-specification/copyright.txt
```

This command generates some of the files in this project, which are marked with // Code generated by go-swagger; DO NOT EDIT.
comments at the top of the files. These are not to be edited, as they are overwritten when specification is changed and the above-mentioned command is run. If you want to change those files, please change the specification where necessary and then generate them again.

## Commit Messages and General Style

For commit messages and general style please follow the haproxy project's [CONTRIBUTING guide](https://github.com/haproxy/haproxy/blob/master/CONTRIBUTING) and use that where applicable.
